package prueba;

import entradaSalida.SalidaPorDefecto;
import estructurasLineales.ListaEstaticaNumerica;
import estructurasNoLineales.Matriz2;
import estructurasNoLineales.Matriz2Numerica;
import estructurasNoLineales.TipoLogaritmo;

public class PruebaMatrizNumerica {
    public static void main(String[] args) {
        Matriz2Numerica matriz = new Matriz2Numerica(4,4, 0);
        Matriz2Numerica matriz2 = new Matriz2Numerica(4,4, 0);
        ListaEstaticaNumerica lista = new ListaEstaticaNumerica(16);
        lista.agregar(2);
        lista.agregar(5);
        lista.agregar(3);
        lista.agregar(4);
        lista.agregar(2);
        lista.agregar(5);
        lista.agregar(3);
        lista.agregar(4);
        lista.agregar(2);
        lista.agregar(5);
        lista.agregar(3);
        lista.agregar(4);
        lista.agregar(2);
        lista.agregar(5);
        lista.agregar(3);
        lista.agregar(4);
        SalidaPorDefecto.consola("-----MATRICES-----\n");
        SalidaPorDefecto.consola("matriz 1\n");
        matriz.imprimirXRenglones();
        SalidaPorDefecto.consola("matriz 2\n");
        matriz2.imprimirXRenglones();
        SalidaPorDefecto.consola("-----LISTA ESCALARES-----\n");
        lista.imprimir();
        SalidaPorDefecto.consola("-----CAMBIO DE VALORES-----\n");
        SalidaPorDefecto.consola("matriz 1\n");
        matriz.cambiar(0,0,6);
        matriz.cambiar(0,1,5);
        matriz.cambiar(0,2,4);
        matriz.cambiar(0,3,3);
        matriz.cambiar(1,0,6);
        matriz.cambiar(1,1,5);
        matriz.cambiar(1,2,4);
        matriz.cambiar(1,3,3);
        matriz.cambiar(2,0,6);
        matriz.cambiar(2,1,5);
        matriz.cambiar(2,2,4);
        matriz.cambiar(2,3,3);
        matriz.cambiar(3,0,6);
        matriz.cambiar(3,1,5);
        matriz.cambiar(3,2,4);
        matriz.cambiar(3,3,3);
        matriz.imprimirXRenglones();
        SalidaPorDefecto.consola("matriz 2\n");
        matriz2.cambiar(0,0,10);
        matriz2.cambiar(0,1,20);
        matriz2.cambiar(0,2,5);
        matriz2.cambiar(0,3,100);
        matriz2.cambiar(1,0,10);
        matriz2.cambiar(1,1,20);
        matriz2.cambiar(1,2,5);
        matriz2.cambiar(1,3,100);
        matriz2.cambiar(2,0,10);
        matriz2.cambiar(2,1,20);
        matriz2.cambiar(2,2,5);
        matriz2.cambiar(2,3,100);
        matriz2.cambiar(3,0,10);
        matriz2.cambiar(3,1,20);
        matriz2.cambiar(3,2,5);
        matriz2.cambiar(3,3,100);

        matriz2.imprimirXRenglones();

        SalidaPorDefecto.consola("-----OBTENER VALORES-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 1\n");
        SalidaPorDefecto.consola("fila 0 col 0: " + matriz.obtener(0,0) +"\n");
        SalidaPorDefecto.consola("fila 1 col 0: " + matriz.obtener(1,0) +"\n");
        SalidaPorDefecto.consola("fila 0 col 4: " + matriz.obtener(0,1) +"\n");

        SalidaPorDefecto.consola("-----POR ESCALAR-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 1\n");
        matriz.porEscalar(10);
        matriz.imprimirXRenglones();

        SalidaPorDefecto.consola("-----POR ESCALAR LISTA-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 1\n");
        matriz.cambiar(0,0,6);
        matriz.cambiar(0,1,5);
        matriz.cambiar(0,2,4);
        matriz.cambiar(0,3,3);
        matriz.cambiar(1,0,6);
        matriz.cambiar(1,1,5);
        matriz.cambiar(1,2,4);
        matriz.cambiar(1,3,3);
        matriz.cambiar(2,0,6);
        matriz.cambiar(2,1,5);
        matriz.cambiar(2,2,4);
        matriz.cambiar(2,3,3);
        matriz.cambiar(3,0,6);
        matriz.cambiar(3,1,5);
        matriz.cambiar(3,2,4);
        matriz.cambiar(3,3,3);
        matriz.porEscalares(lista);
        matriz.imprimirXRenglones();

        SalidaPorDefecto.consola("-----SUMA ESCALAR-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 1\n");
        matriz.cambiar(0,0,6);
        matriz.cambiar(0,1,5);
        matriz.cambiar(0,2,4);
        matriz.cambiar(0,3,3);
        matriz.cambiar(1,0,6);
        matriz.cambiar(1,1,5);
        matriz.cambiar(1,2,4);
        matriz.cambiar(1,3,3);
        matriz.cambiar(2,0,6);
        matriz.cambiar(2,1,5);
        matriz.cambiar(2,2,4);
        matriz.cambiar(2,3,3);
        matriz.cambiar(3,0,6);
        matriz.cambiar(3,1,5);
        matriz.cambiar(3,2,4);
        matriz.cambiar(3,3,3);
        matriz.sumarEscalar(5);
        matriz.imprimirXRenglones();

        SalidaPorDefecto.consola("-----SUMAR ESCALAR LISTA-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 1\n");
        matriz.cambiar(0,0,6);
        matriz.cambiar(0,1,5);
        matriz.cambiar(0,2,4);
        matriz.cambiar(0,3,3);
        matriz.cambiar(1,0,6);
        matriz.cambiar(1,1,5);
        matriz.cambiar(1,2,4);
        matriz.cambiar(1,3,3);
        matriz.cambiar(2,0,6);
        matriz.cambiar(2,1,5);
        matriz.cambiar(2,2,4);
        matriz.cambiar(2,3,3);
        matriz.cambiar(3,0,6);
        matriz.cambiar(3,1,5);
        matriz.cambiar(3,2,4);
        matriz.cambiar(3,3,3);
        matriz.sumarEscalares(lista);
        matriz.imprimirXRenglones();

        SalidaPorDefecto.consola("-----MULTIPLICAR MATRICES-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 1 y 2\n");
        matriz.cambiar(0,0,6);
        matriz.cambiar(0,1,5);
        matriz.cambiar(0,2,4);
        matriz.cambiar(0,3,3);
        matriz.cambiar(1,0,6);
        matriz.cambiar(1,1,5);
        matriz.cambiar(1,2,4);
        matriz.cambiar(1,3,3);
        matriz.cambiar(2,0,6);
        matriz.cambiar(2,1,5);
        matriz.cambiar(2,2,4);
        matriz.cambiar(2,3,3);
        matriz.cambiar(3,0,6);
        matriz.cambiar(3,1,5);
        matriz.cambiar(3,2,4);
        matriz.cambiar(3,3,3);
        matriz.multiplicar(matriz2);
        matriz.imprimirXRenglones();

        SalidaPorDefecto.consola("-----SUMAR MATRICES-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 1\n");
        matriz.cambiar(0,0,6);
        matriz.cambiar(0,1,5);
        matriz.cambiar(0,2,4);
        matriz.cambiar(0,3,3);
        matriz.cambiar(1,0,6);
        matriz.cambiar(1,1,5);
        matriz.cambiar(1,2,4);
        matriz.cambiar(1,3,3);
        matriz.cambiar(2,0,6);
        matriz.cambiar(2,1,5);
        matriz.cambiar(2,2,4);
        matriz.cambiar(2,3,3);
        matriz.cambiar(3,0,6);
        matriz.cambiar(3,1,5);
        matriz.cambiar(3,2,4);
        matriz.cambiar(3,3,3);
        matriz.sumar(matriz2);
        matriz.imprimirXRenglones();

        SalidaPorDefecto.consola("-----POTENCIA A UNA MATRIZ-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 2\n");
        matriz2.aplicarPotencia(2);
        matriz2.imprimirXRenglones();

        SalidaPorDefecto.consola("-----LOGARITMOS-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 2\n");
        matriz2.cambiar(0,0,10);
        matriz2.cambiar(0,1,20);
        matriz2.cambiar(0,2,5);
        matriz2.cambiar(0,3,100);
        matriz2.cambiar(1,0,10);
        matriz2.cambiar(1,1,20);
        matriz2.cambiar(1,2,5);
        matriz2.cambiar(1,3,100);
        matriz2.cambiar(2,0,10);
        matriz2.cambiar(2,1,20);
        matriz2.cambiar(2,2,5);
        matriz2.cambiar(2,3,100);
        matriz2.cambiar(3,0,10);
        matriz2.cambiar(3,1,20);
        matriz2.cambiar(3,2,5);
        matriz2.cambiar(3,3,100);
        SalidaPorDefecto.consola("--natural\n");
        matriz2.aplicarLogaritmo(TipoLogaritmo.NATURAL);
        matriz2.imprimirXRenglones();
        matriz2.cambiar(0,0,10);
        matriz2.cambiar(0,1,20);
        matriz2.cambiar(0,2,5);
        matriz2.cambiar(0,3,100);
        matriz2.cambiar(1,0,10);
        matriz2.cambiar(1,1,20);
        matriz2.cambiar(1,2,5);
        matriz2.cambiar(1,3,100);
        matriz2.cambiar(2,0,10);
        matriz2.cambiar(2,1,20);
        matriz2.cambiar(2,2,5);
        matriz2.cambiar(2,3,100);
        matriz2.cambiar(3,0,10);
        matriz2.cambiar(3,1,20);
        matriz2.cambiar(3,2,5);
        matriz2.cambiar(3,3,100);
        SalidaPorDefecto.consola("--base 10\n");
        matriz2.aplicarLogaritmo(TipoLogaritmo.BASE10);
        matriz2.imprimirXRenglones();
        matriz2.cambiar(0,0,10);
        matriz2.cambiar(0,1,20);
        matriz2.cambiar(0,2,5);
        matriz2.cambiar(0,3,100);
        matriz2.cambiar(1,0,10);
        matriz2.cambiar(1,1,20);
        matriz2.cambiar(1,2,5);
        matriz2.cambiar(1,3,100);
        matriz2.cambiar(2,0,10);
        matriz2.cambiar(2,1,20);
        matriz2.cambiar(2,2,5);
        matriz2.cambiar(2,3,100);
        matriz2.cambiar(3,0,10);
        matriz2.cambiar(3,1,20);
        matriz2.cambiar(3,2,5);
        matriz2.cambiar(3,3,100);
        SalidaPorDefecto.consola("--base 2\n");
        matriz2.aplicarLogaritmo(TipoLogaritmo.BASE2);
        matriz2.imprimirXRenglones();

        SalidaPorDefecto.consola("-----MATRIZ DIAGONAL-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 1\n");
        matriz.cambiar(0,0,6);
        matriz.cambiar(0,1,5);
        matriz.cambiar(0,2,4);
        matriz.cambiar(0,3,3);
        matriz.cambiar(1,0,6);
        matriz.cambiar(1,1,5);
        matriz.cambiar(1,2,4);
        matriz.cambiar(1,3,3);
        matriz.cambiar(2,0,6);
        matriz.cambiar(2,1,5);
        matriz.cambiar(2,2,4);
        matriz.cambiar(2,3,3);
        matriz.cambiar(3,0,6);
        matriz.cambiar(3,1,5);
        matriz.cambiar(3,2,4);
        matriz.cambiar(3,3,3);
        matriz.matrizDiagonal(1);
        matriz.imprimirXRenglones();

        SalidaPorDefecto.consola("-----POTENCIA CON VALOR INT-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 1\n");
        matriz.cambiar(0,0,6);
        matriz.cambiar(0,1,5);
        matriz.cambiar(0,2,4);
        matriz.cambiar(0,3,3);
        matriz.cambiar(1,0,6);
        matriz.cambiar(1,1,5);
        matriz.cambiar(1,2,4);
        matriz.cambiar(1,3,3);
        matriz.cambiar(2,0,6);
        matriz.cambiar(2,1,5);
        matriz.cambiar(2,2,4);
        matriz.cambiar(2,3,3);
        matriz.cambiar(3,0,6);
        matriz.cambiar(3,1,5);
        matriz.cambiar(3,2,4);
        matriz.cambiar(3,3,3);
        matriz.potencia(2);
        matriz.imprimirXRenglones();

        SalidaPorDefecto.consola("-----DOBLADO COLUMNAS-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 1\n");
        matriz.cambiar(0,0,6);
        matriz.cambiar(0,1,5);
        matriz.cambiar(0,2,4);
        matriz.cambiar(0,3,3);
        matriz.cambiar(1,0,6);
        matriz.cambiar(1,1,5);
        matriz.cambiar(1,2,4);
        matriz.cambiar(1,3,3);
        matriz.cambiar(2,0,6);
        matriz.cambiar(2,1,5);
        matriz.cambiar(2,2,4);
        matriz.cambiar(2,3,3);
        matriz.cambiar(3,0,6);
        matriz.cambiar(3,1,5);
        matriz.cambiar(3,2,4);
        matriz.cambiar(3,3,3);
        matriz.doblarColumnas();
        matriz.imprimirXRenglones();

        SalidaPorDefecto.consola("-----DOBLADO RENGLONES-----\n");
        SalidaPorDefecto.consola("se utiliza la matriz 1\n");
        matriz.redefinir(matriz2);
        matriz.cambiar(0,0,6);
        matriz.cambiar(0,1,5);
        matriz.cambiar(0,2,4);
        matriz.cambiar(0,3,3);
        matriz.cambiar(1,0,6);
        matriz.cambiar(1,1,5);
        matriz.cambiar(1,2,4);
        matriz.cambiar(1,3,3);
        matriz.cambiar(2,0,6);
        matriz.cambiar(2,1,5);
        matriz.cambiar(2,2,4);
        matriz.cambiar(2,3,3);
        matriz.cambiar(3,0,6);
        matriz.cambiar(3,1,5);
        matriz.cambiar(3,2,4);
        matriz.cambiar(3,3,3);
        matriz.doblarRenglones();
        matriz.imprimirXRenglones();

        SalidaPorDefecto.consola("-----DIAGONAL SUPERIOR-----\n");
        SalidaPorDefecto.consola("¿la matriz 1 es diagonal superior? " + matriz.esDiagonalSuperior() + "\n");

        SalidaPorDefecto.consola("-----DIAGONAL INFERIOR-----\n");
        SalidaPorDefecto.consola("¿la matriz 1 es diagonal inferior? " + matriz.esDiagonalSuperior() + "\n");
    }
}
